module NsSettingsUi
  module SettingsHelper
    def setting_value_class(setting)
      return 'alert-danger' if setting.value.nil? || setting.value.empty?
      return 'alert-warning' if setting.value != setting.default_value
      ''
    end

    def render_value_field(form, setting)
      render_field(form, setting.value_type, :value, setting_value_class(setting))
    end

    def render_default_value_field(form, setting)
      render_field(form, setting.value_type, :default_value)
    end

    private

    def render_field(form, value_type, name, additional_class = '')
      base_css_classes = 'form-select form-select-sm'
      if [NsSettingsUi::Setting::TYPES[:boolean], NsSettingsUi::Setting::TYPES[:nullable_boolean]].include?(value_type)
        form.select(name, [[:true, 'true'], [:false, 'false']], {include_blank: true}, class: base_css_classes)
      else
        form.text_field(name, size: 10, class: "#{base_css_classes} #{additional_class}")
      end
    end

    def recursive_hash
      Hash.new { |hash, key| hash[key] = recursive_hash }
    end
  end
end
