#!/usr/bin/bash
EXIT_CODE=0

while IFS= read -r version; do
  printf '\n\nTesting %s\n\n' "$version"
  bundle exec appraisal "$version" rake db:schema:load
  bundle exec appraisal "$version" rspec spec
  LAST_EXIT_CODE=$?

  if [ $EXIT_CODE == 0 ]; then
    EXIT_CODE=$LAST_EXIT_CODE
  fi
done <<< "$(bundle exec appraisal list)"

exit $EXIT_CODE
